The rest of this file are patches to get p3nfsd.pl6 to work under Linux.
BTW The Linux port of p3nfsd was originally done by
	Lee McLoughlin <lmjm@doc.ic.ac.uk>


diff -cbrw p3nfs.pl6/Makefile p3nfs.pl6-linux/Makefile
*** p3nfs.pl6/Makefile	Wed Aug 10 12:46:53 1994
--- p3nfs.pl6-linux/Makefile	Mon Aug 15 08:31:52 1994
***************
*** 1,6 ****
  CC	=	cc
! CFLAGS	=	-g
  #CFLAGS	=	-g -Wall # -O6
  
  AIXLIBS	=	-lbsd
  
--- 1,7 ----
  CC	=	cc
! CFLAGS	=	-g -DDDIR=\"/psion/mnt\"
  #CFLAGS	=	-g -Wall # -O6
+ LDFLAGS =	$(CFLAGS)
  
  AIXLIBS	=	-lbsd
  
diff -cbrw p3nfs.pl6/config.h p3nfs.pl6-linux/config.h
*** p3nfs.pl6/config.h	Wed Jul 27 14:14:48 1994
--- p3nfs.pl6-linux/config.h	Mon Aug 15 08:32:22 1994
***************
*** 21,27 ****
--- 21,29 ----
  #endif
  
  #define DUSER "root"
+ #ifndef DDIR
  #define DDIR "/psion.stand/mnt"
+ #endif
  
  #define DSPEED 19200
  
diff -cbrw p3nfs.pl6/mp_mount.c p3nfs.pl6-linux/mp_mount.c
*** p3nfs.pl6/mp_mount.c	Wed Jul 27 14:14:48 1994
--- p3nfs.pl6-linux/mp_mount.c	Mon Aug 15 08:36:36 1994
***************
*** 127,133 ****
--- 127,135 ----
  #endif
  
    bzero(&sain, sizeof(struct sockaddr_in));
+ #ifndef linux
    bzero(&nfs_args, sizeof(struct nfs_args));
+ #endif
  
  /*** First part: set up the rpc service */
  /* Create udp socket */
diff -cbrw p3nfs.pl6/nfs_prot.h p3nfs.pl6-linux/nfs_prot.h
*** p3nfs.pl6/nfs_prot.h	Wed Jul 27 14:14:49 1994
--- p3nfs.pl6-linux/nfs_prot.h	Mon Aug 15 08:30:06 1994
***************
*** 2,7 ****
--- 2,11 ----
  #include <sys/time.h>
  #include <nfs/nfs.h>
  #endif
+ #ifdef linux
+ #include <sys/time.h>
+ #include <linux/nfs.h>
+ #endif
  
  /*
   * Please do not edit this file.
***************
*** 16,22 ****
  #define NFS_MAXNAMLEN 255
  #define NFS_FHSIZE 32
  #define NFS_COOKIESIZE 4
! #ifndef hpux
  #define NFS_FIFO_DEV -1
  #endif
  #define NFSMODE_FMT 0170000
--- 20,26 ----
  #define NFS_MAXNAMLEN 255
  #define NFS_FHSIZE 32
  #define NFS_COOKIESIZE 4
! #ifndef NFS_FIFO_DEV
  #define NFS_FIFO_DEV -1
  #endif
  #define NFSMODE_FMT 0170000
***************
*** 28,34 ****
  #define NFSMODE_SOCK 0140000
  #define NFSMODE_FIFO 0010000
  
! #ifndef hpux
  enum nfsstat {
  	NFS_OK = 0,
  	NFSERR_PERM = 1,
--- 32,38 ----
  #define NFSMODE_SOCK 0140000
  #define NFSMODE_FIFO 0010000
  
! #if !defined(hpux) && !defined(linux)
  enum nfsstat {
  	NFS_OK = 0,
  	NFSERR_PERM = 1,
***************
*** 49,60 ****
  	NFSERR_STALE = 70,
  	NFSERR_WFLUSH = 99,
  };
! #endif /* hpux */
  
  typedef enum nfsstat nfsstat;
  bool_t xdr_nfsstat();
  
! #ifndef hpux
  enum ftype {
  	NFNON = 0,
  	NFREG = 1,
--- 53,68 ----
  	NFSERR_STALE = 70,
  	NFSERR_WFLUSH = 99,
  };
! #endif /* hpux, linux */
  
+ #ifndef linux
  typedef enum nfsstat nfsstat;
+ #else
+ typedef enum nfs_stat nfsstat;
+ #endif
  bool_t xdr_nfsstat();
  
! #if !defined(hpux) && !defined(linux)
  enum ftype {
  	NFNON = 0,
  	NFREG = 1,
***************
*** 67,80 ****
  	NFFIFO = 8,
  };
  typedef enum ftype ftype;
! #else
  typedef enum nfsftype ftype;
! #endif /* hpux */
  bool_t xdr_ftype();
  
  struct nfs_fh {
  	char data[NFS_FHSIZE];
  };
  typedef struct nfs_fh nfs_fh;
  bool_t xdr_nfs_fh();
  
--- 75,94 ----
  	NFFIFO = 8,
  };
  typedef enum ftype ftype;
! #endif /* hpux, linux */
! #ifdef hpux
  typedef enum nfsftype ftype;
! #endif
! #ifdef linux
! typedef enum nfs_ftype ftype;
! #endif
  bool_t xdr_ftype();
  
+ #ifndef linux
  struct nfs_fh {
  	char data[NFS_FHSIZE];
  };
+ #endif
  typedef struct nfs_fh nfs_fh;
  bool_t xdr_nfs_fh();
  
***************
*** 294,334 ****
--- 308,388 ----
  typedef struct statfsres statfsres;
  bool_t xdr_statfsres();
  
+ #ifndef NFS_PROGRAM
  #define NFS_PROGRAM ((u_long)100003)
+ #endif
+ #ifndef  NFS_VERSION
  #define NFS_VERSION ((u_long)2)
+ #endif
+ #ifndef  NFSPROC_NULL
  #define NFSPROC_NULL ((u_long)0)
+ #endif
  extern void *nfsproc_null_2();
+ #ifndef  NFSPROC_GETATTR
  #define NFSPROC_GETATTR ((u_long)1)
+ #endif
  extern attrstat *nfsproc_getattr_2();
+ #ifndef  NFSPROC_SETATTR
  #define NFSPROC_SETATTR ((u_long)2)
+ #endif
  extern attrstat *nfsproc_setattr_2();
+ #ifndef  NFSPROC_ROOT
  #define NFSPROC_ROOT ((u_long)3)
+ #endif
  extern void *nfsproc_root_2();
+ #ifndef  NFSPROC_LOOKUP
  #define NFSPROC_LOOKUP ((u_long)4)
+ #endif
  extern diropres *nfsproc_lookup_2();
+ #ifndef  NFSPROC_READLINK
  #define NFSPROC_READLINK ((u_long)5)
+ #endif
  extern readlinkres *nfsproc_readlink_2();
+ #ifndef  NFSPROC_READ
  #define NFSPROC_READ ((u_long)6)
+ #endif
  extern readres *nfsproc_read_2();
+ #ifndef  NFSPROC_WRITECACHE
  #define NFSPROC_WRITECACHE ((u_long)7)
+ #endif
  extern void *nfsproc_writecache_2();
+ #ifndef  NFSPROC_WRITE
  #define NFSPROC_WRITE ((u_long)8)
+ #endif
  extern attrstat *nfsproc_write_2();
+ #ifndef  NFSPROC_CREATE
  #define NFSPROC_CREATE ((u_long)9)
+ #endif
  extern diropres *nfsproc_create_2();
+ #ifndef  NFSPROC_REMOVE
  #define NFSPROC_REMOVE ((u_long)10)
+ #endif
  extern nfsstat *nfsproc_remove_2();
+ #ifndef  NFSPROC_RENAME
  #define NFSPROC_RENAME ((u_long)11)
+ #endif
  extern nfsstat *nfsproc_rename_2();
+ #ifndef  NFSPROC_LINK
  #define NFSPROC_LINK ((u_long)12)
+ #endif
  extern nfsstat *nfsproc_link_2();
+ #ifndef  NFSPROC_SYMLINK
  #define NFSPROC_SYMLINK ((u_long)13)
+ #endif
  extern nfsstat *nfsproc_symlink_2();
+ #ifndef  NFSPROC_MKDIR
  #define NFSPROC_MKDIR ((u_long)14)
+ #endif
  extern diropres *nfsproc_mkdir_2();
+ #ifndef  NFSPROC_RMDIR
  #define NFSPROC_RMDIR ((u_long)15)
+ #endif
  extern nfsstat *nfsproc_rmdir_2();
+ #ifndef  NFSPROC_READDIR
  #define NFSPROC_READDIR ((u_long)16)
+ #endif
  extern readdirres *nfsproc_readdir_2();
+ #ifndef  NFSPROC_STATFS
  #define NFSPROC_STATFS ((u_long)17)
+ #endif
  extern statfsres *nfsproc_statfs_2();
